<?php if (!defined('PmWiki')) exit();
/*
    simple citations script, version 1.22
    Copyright 2006-2007 John Rankin (john.rankin@affinity.co.nz)
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.    
*/
$ExtendAlpha = "A-Za-z\xc0-\xd6\xd8-\xf6\xf8-\xff";
$CitePattern = "[$ExtendAlpha][-.:0-9$ExtendAlpha]*";
SDV($CiteAbbrPattern, "[[:upper:]][[:alpha:]]+");
If ($action=='print' || $action=='publish') {
  SDV($LinkCiteCreateFmt, '$Cite %red%(?)%%');
  SDV($LinkCiteEditFmt, '');
  SDV($LinkAbbrCreateFmt, '$Abbr %red%(?)%%');
} else {
  SDV($LinkCiteCreateFmt, "</a><a rel='nofollow' class='createlinktext' 
  href='{\$PageUrl}?action=cite&amp;refid=\$Cite&amp;pick=y'>\$Cite</a><a rel='nofollow' 
  class='createlink' href='{\$PageUrl}?action=cite&amp;refid=\$Cite&amp;pick=y'>(?)");
  SDV($LinkCiteEditFmt, " <span class='citedit'><a rel='nofollow' 
  class='citelink' href='{\$PageUrl}?action=cite&amp;refid=\$Cite'>(edit)</a></span>");
  SDV($LinkAbbrCreateFmt, "<a rel='nofollow' class='createlinktext' 
  href='{\$PageUrl}?action=abbr&amp;abbr=\$Abbr&amp;return=\$APage'>\$Abbr</a><a rel='nofollow' 
  class='createlink' href='{\$PageUrl}?action=abbr&amp;abbr=\$Abbr&amp;return=\$APage'>(?)</a>");
}
SDV($CiteSpacedFunction, 'CiteSpaced');

### --- this block of code processes cite(key) and (:bib:) markup --- ###

# first, log all instances of cite(key) markup
Markup('citations','>include',
  "/((\*|no)?[Cc])ite(-?[PpTtYy]?\((\"[^\"]*\"\s*)?($CitePattern)(\s*\"[^\"]*\")?\))/e",
  "(('$2'=='no') ? 'cite($5\"*\")' : '$1ite'.PSS('$3')).
  (SeenCitation('cite','$5') ? '' : '')");
function SeenCitation($x,$y) { global $SeenCite; return @$SeenCite[$x][$y]++; }

# next, build a list of citations defined in a (:bib:) ... (:bibend:) block
Markup('bib','>citations',
  "/\(:bib(\s.*?)?:\)\n(.*?)\n\(:bibend:\)/se",
  "ListCitations(\$pagename, ParseArgs(PSS('$1')), PSS('$2'))");
SDV($MarkupFrameBase['posteval']['bib'], 
  "\$out = preg_replace('/(<div\s+id=\"references\">.*?<\/div>)(.*?)$/s','$2$1',\$out);");

# take a citation key and turn it into a human-friendly format
# it really likes keys of the form author1:author2:year
function CiteSpaced($txt) {
  $upper = "A-Z\xc0-\xd6\xd8-\xde";
  $lower = "a-z\xdf-\xf6\xf8-\xff";
# Soo:Grabbitt:Runn:2006 --> Soo, Grabbitt:Runn:2006
  while (preg_match("/([$lower])[.:]([$upper][^.:]*[.:][$upper])/",$txt,$match))
    $txt = str_replace($match[0],"$match[1], $match[2]", $txt);
#  $txt = preg_replace("/([$lower])[.:]([$upper][^.:]*[.:][$upper])/", 
#    '$1, $2', $txt);
# Grabbitt:Runn:2006 --> Grabbitt and Runn:2006
  $txt = preg_replace("/^([^\s]*[$lower])[.:]([$upper])/", '$1 and $2', $txt);
# Soo, Grabbitt:Runn:2006 --> Soo, Grabbitt, and Runn:2006
  $txt = preg_replace("/([$lower])[.:]([$upper])/", '$1, and $2', $txt);
# Soo, Grabbitt and Runn:2006 --> Soo, Grabbitt and Runn (2006)
# ...:2006a:JIR --> ... (2006a JIR)
  $txt = preg_replace("/([$lower$upper])[.:]?(\d{4}[a-z]?)(?:[.:]([$upper]+))?$/e", 
    "'$1 ($2'.('$3' ? ' $3' : '').')'", $txt);
# dAlembert --> d'Alembert
  $txt = preg_replace("/((^|\s)[dl])([AEIOU])/", '$1&rsquo;$3', $txt);
# vonGaza --> von Gaza
  $txt = preg_replace("/((^|\s)[$lower]+)([$upper])/", '$1 $3', $txt);
# OReilly --> O'Reilly
  $txt = preg_replace("/((^|\s)O)([[:upper:]][$lower])/", '$1&rsquo;$3', $txt);
# Smith:etal or SmithEtal --> Smith et al.
  $txt = preg_replace("/([$lower])([.:]e|E)tal\s/", '$1 et al. ', $txt);
# WikiWord --> Wiki Word
  $txt = preg_replace("/(?:(Ma?c)|([$lower]+))([$upper])/e",
   "('$1' ? '$1' : '$2 ').'$3'", $txt);
#  $txt = preg_replace("/([$lower]+)([$upper])/", '$1 $2', $txt);
# Smith:von Gaza --> Smith and von Gaza (works for Smith:others too)
  return preg_replace("/([$lower])[.:]([$lower])/", '$1 and $2', $txt);
}

# given a pagename, extraxt the citations from it for re-use
# return the text block within a (:bib:) ... (:bibend:) directive pair
function IncludeCitations($page, $p) {
  $pg = MakePageName($page,$p);
  if ($page!=$pg && PageExists($pg))
    $ipage = RetrieveAuthPage($pg, 'read', false, READPAGE_CURRENT);
  return preg_match('/\(:bib(\s.*?)?:\)(.*?)\(:bibend:\)/s',
    MarkupEscape(@$ipage['text']),$b) ? PVS(htmlspecialchars($b[2], ENT_NOQUOTES)) : '';
}
# given a pagename, extract citation abbreviations and their expansions
# return an array of abbreviations and their values
function AbbreviateVariables($page, $p, $pattern) {
  $pg = MakePageName($page,$p);  $r = array();
  if ($page!=$pg && PageExists($pg))
    $apage = RetrieveAuthPage($pg, 'read', false, READPAGE_CURRENT);
  foreach(explode("\n", MarkupEscape(@$apage['text'])) as $t)
    if (preg_match("/^:?($pattern)\s*:\s*(.*)$/",$t,$m)) $r[$m[1]] = $m[2];
  return $r;
}
# make a link to a form for defining a new abbreviation
function MakeAbbreviationLink($page, $p, $abbr) {
  global $LinkAbbrCreateFmt, $FmtV;
  $FmtV['$APage'] = $page;
  $FmtV['$Abbr']  = $abbr;
  return Keep(FmtPageName($LinkAbbrCreateFmt,MakePageName($page,$p)),'L');
}

# create a list of references on a page, for display at the end of the page
# supports numbered and author year citations, sorted or unsorted
# recognises and reports duplicate citation keys
# an author can include the bibliographies on other pages
function ListCitations($page,$opt,$text) {
  global $CitationList, $SeenCite, $CiteSpacedFunction, $CiteOpt, $HTMLFooterFmt,
    $ReferenceTag, $CitePattern, $NumberReferences, $CiteAbbrPattern, $LongestCiteKey;
  SDV($ReferenceTag, array('o' => '<div id="references">', 'c' => '</div>'));
  SDVA($CiteOpt, array('fmt' => 'text', 'duplicates' => 'Duplicate reference(s)', 
    'title' => 'References for '."'/".'{$Title}'."/'", 'none' => 'none cited', 
    'more' => 'Further reading', 'access' => ', accessed on %d %B %Y.', 'sort' => 'yes'));
  $opt = array_merge($CiteOpt, (array)$opt); $tx = $text;
  if (@$opt['page'])
    foreach(preg_split("/,?[\\s|]+/", $opt['page'], -1, PREG_SPLIT_NO_EMPTY) as $p)
      $text .= IncludeCitations($page, $p);
  $DuplicateList[] = $opt['duplicates'];
  $CitationList = array('reftext' => array(), 'citetext' => array(), 'bibtext' => array());
  $ReferenceList = array();
  if (@$opt['abbr']) {
    $AbbreviationList = AbbreviateVariables($page, $opt['abbr'], $CiteAbbrPattern);
    $text = preg_replace("/\{($CiteAbbrPattern)\}/e",
      "\$AbbreviationList['$1'] ? \$AbbreviationList['$1'] :
      MakeAbbreviationLink(\$page,'{$opt['abbr']}','$1')",$text);
  }
  foreach(preg_split("/\n[*#:]\s*/","\n".$text, -1, PREG_SPLIT_NO_EMPTY) as $t)
    if (preg_match("/^($CitePattern?)(?:\s*\"([^\"]*)\"(?:([^\"]*)\")?)?(?:\s*[.:])?\s+(.*?)$/s",
      $t,$m)) {
      @list($line, $ref, $reftext, $refid, $citetext) = $m;
      $citetext = preg_replace("/([^\\\\])\n.*?$/s",'$1',$citetext);
      $citetext = preg_replace('/"(\d{4})-(0[1-9]|1[0-2])-(0[1-9]|[12][0-9]|3[01])"/e',
        "strftime('{$opt['access']}',mktime(0,0,0,'$2','$3','$1'))",$citetext);
      if (@$ReferenceTag['n'])
        $citetext = str_replace("\\\n", $ReferenceTag['n'], $citetext);
      if (@$opt['keys']) $citetext .= " '''$ref'''";
      $ir = strtolower($ref);
      if (@$SeenCite['cite'][$ref]) {
        if (SeenCitation('ref',$ref)) $DuplicateList[] = "\n* $line";
        else {
          $CitationList['reftext'][$ir]  = $reftext ? $reftext : $CiteSpacedFunction($ref);
      	  $CitationList['citetext'][$ir] = 
            '[[#' . MakeValidCite($ref) . ']] ' . EditCiteLink($page,$ref,$tx) . $citetext;
          if ($refid) $ReferenceList[$ir] = $refid;
/*
          if (preg_match('/^([^,]+),\s([^\\\]*?(?:[A-Z]\.)*)([,.]\s|\s(?:and|&amp;))/',
                  $citetext,$author)) {
            $dot = (preg_match('/[A-Z]$/',$author[2])) ? '.' : '';
            $ReplacementList[$ir] = array('old' => "$author[1], $author[2]",
                                          'new' => "$author[2]$dot $author[1]",
                                          'go'  => (@$opt['names'] ? true : false));
           }
*/
#          $j++;
#          $maxlen = max(@$maxlen,strlen($refid ? $refid : (@$opt['keys'] ? $ref : "$j")));
        }
      } else $CitationList['bibtext'][$ir] = EditCiteLink($page,$ref,$tx) . $citetext;
    }
  $bib = ((@$opt['fmt']=='bib') ? 'bib' : 'cite') .'text';
  if (@$opt['sort']=='yes' || @$opt['sort']=='ref') ksort($CitationList[$bib]);
  if (@$opt['fmt']=='#' || @$opt['fmt']=='num') {
    $NumberReferences = @$opt['keys'] ? 2 : 1; $space = '&nbsp; ';
    if (@$opt['sort']=='cite') { 
      foreach($SeenCite['cite'] as $r => $c) {
        $ir = strtolower($r);
        $temp[$ir] = $CitationList[$bib][$ir];
      }
      $CitationList[$bib] = $temp;
      $opt['sort'] = 'bib';
    }
    $LongestCiteKey = 'x';
    foreach($CitationList[$bib] as $r => $c) { 
      $i++;
#      if (@$ReplacementList[$r]['go'])
#        $c = str_replace($ReplacementList[$r]['old'],$ReplacementList[$r]['new'],$c);
      if (@$opt['keys']) {
        preg_match("/^(\[\[#.*?\]\]\s*)(.*?)\s'''(.*?)'''$/s",$c,$mat); 
        $c = $mat[1]. '"' . ReferenceText('','-P',$mat[3],'','','') . '" -- ' . $mat[2];
      }
/*
        $c = $mat[1]; 
        $o = @$ReferenceList[$r] ? "''".$ReferenceList[$r]."''" : 
          ReferenceText('','-P',$mat[2],'','');
        if (@$ReferenceList[$r]) {
          if (preg_match('/\((\d{4})[a-z]?(.*?)\)$/',$CitationList['reftext'][$r],$ym))
            $CitationList['reftext'][$r] = preg_replace('/\(\d{4}[a-z]?(.*?)\)$/', 
              "$ym[1] ($o)",$CitationList['reftext'][$r]);
          else 
            $CitationList['reftext'][$r] .= " ($o)";
        }
      } else {
*/
        $o = @$ReferenceList[$r] ? $ReferenceList[$r] : "$i";
        if (preg_match('/\((\d{4})[a-z]?(.*?)\)$/',$CitationList['reftext'][$r],$ym))
          $CitationList['reftext'][$r] = preg_replace('/\(\d{4}[a-z]?(.*?)\)$/', 
            "$ym[1] ($o)",$CitationList['reftext'][$r]);
        else 
          $CitationList['reftext'][$r] .= " ($o)";
#      }
      if (strlen($o)>strlen($LongestCiteKey)) $LongestCiteKey = $o;
      $CitationList[$bib][$r] = "[$o] ".
#        ((strlen($o)<$maxlen) ? str_repeat($space,($maxlen-strlen($o))): '').
        "$space$c";
    }
  } else $NumberReferences = 0;
  $all = '';
  if (@$opt['fmt']=='*' || @$opt['fmt']=='#') {
    $cit = 'bibtext';
    if (@$opt['sort']=='yes' || @$opt['sort']=='bib') ksort($CitationList[$cit]);
    if (count($CitationList[$cit]))
      $all = "\nR:{$opt['more']}\nF:".implode("\nF:",$CitationList[$cit]);
  }
  $BorF = (@$opt['fmt']=='bib') ? 'F' : 'B';
  $SeenCite = array('cite' => array(), 'ref' => array());
  return (count($DuplicateList)>1 ? implode("\n",$DuplicateList) : '').
    "\n".$ReferenceTag['o']."\nR:{$opt['title']}".
      "\n$BorF:".(count($CitationList[$bib]) ? implode("\n$BorF:",$CitationList[$bib]) :
      "[[#none.cited]]''{$opt['none']}''").$all."\n".$ReferenceTag['c'];
}

$HTMLStylesFmt['bib'] = "
#references span.citedit { float: right; width: 2.1em; text-align: right;
     font-size: smaller; }
#references a { text-decoration:none; color:#5f5f30; }
#references a:hover { border-bottom: 1px solid; color:blue; }
p.reference { margin-top: 1.5em; font-weight: bold; }
p.citation  { margin-top: 0.3em; margin-left: 40px; text-indent:-40px; }";

# finally, make links from cite(key) references to the list of citations
Markup('^B:', 'block', '/^([BFR]):(.*)$/e', 
  "'<:block,1><p class=\"'.(('$1'=='R') ? 'reference' : 'citation').'\">'.PSS('$2</p>')");
Markup('cite','<inline',
  "/(\*?[Cc])ite(-?[PpTtYy]?)\((?:\"([^\"]*)\"\s*)?($CitePattern)(?:\s*\"([^\"]*)\")?\)('s)?/e",
  "('$5'=='*') ? '' : '[[#'.MakeValidCite('$4').' |'.
  ReferenceText('$1',('$2' ? '$2' : '*'),'$4',PSS('$3'),PSS('$5'),PSS('$6')).']]'");
SDVA($CitationFormats, array(
  'P'  => array('p' => 'P', 't' => '*'),
  'p'  => array('p' => 'p', 't' => '*'),
  'T'  => array('p' => '*', 't' => 'T'),
  't'  => array('p' => '*', 't' => 't'),
  'Y'  => array('p' => '*', 't' => 'Y'),
  'y'  => array('p' => '*', 't' => 'y'),
  '-'  => array('p' => '*', 't' => 'i'),
  '-P' => array('p' => 'i', 't' => '*'),
  '-p' => array('p' => 'p', 't' => 'i'),
  '-T' => array('p' => 'P', 't' => 'T'),
  '-t' => array('p' => 'p', 't' => 't'),
  '-Y' => array('p' => 'P', 't' => 'Y'),
  '-y' => array('p' => 'i', 't' => 'y'),
  '*'  => array('p' => '*', 't' => '*')
  ));
SDVA($CitationSwitches, array(
  array('Y' => 't', 'y' => 'T', '-Y' => '-t', '-y' => '-T'),
  array('*' => 't', 't' => '*', '-t' => 'p',   'p' => '-t'),
  array('*' => 'P', 'P' => '*')
  ));

# prevent invalid characters from appearing in anchors
function MakeValidCite($txt) {
  return preg_replace('/&([A-Za-z]+);/','$1',htmlentities($txt, ENT_NOQUOTES));
}
# make a link to a form for editing a citation
function EditCiteLink($page,$ref,$txt) {
  global $LinkCiteEditFmt, $FmtV;
  $FmtV['$Cite'] = $ref;
  return preg_match("/[*#:]\s*$ref/",$txt) ? 
    Keep(FmtPageName($LinkCiteEditFmt,$page)) : '';
}
# make a link to a form for creating a citation
function CreateCiteLink($ref) {
  global $LinkCiteCreateFmt, $pagename, $FmtV;
  $FmtV['$Cite'] = $ref;
  return Keep(FmtPageName($LinkCiteCreateFmt,$pagename),'L');
}

# turn cite(key) markup into suitable link text, using the markup options
# returns text with author, year or number, prefixes and suffixes, and brackets
function ReferenceText($etAl,$port,$ref,$pre,$note,$apos) {
  global $CitationList, $NumberReferences, $CitationFormats, $CitationSwitches,
    $SeenCite;
  unset($SeenCite['cite'][$ref]);
  if ($pre) $pre .= ' ';
  if (strlen($etAl)==2) { $c = $etAl[1]; $etAl = $etAl[0]; } else $c = $etAl;
  if (@$CitationSwitches[$NumberReferences][$port])
    $port = $CitationSwitches[$NumberReferences][$port];
  foreach (array('p', 't') as $k) $$k = $CitationFormats[$port][$k];
  if ($p=='i') { $implied = 1; $p = 'P'; } else $implied = 0;
  $ir = strtolower($ref);
  $r = $CitationList['reftext'][$ir] ? $CitationList['reftext'][$ir] : 
    CreateCiteLink($ref);
  if ($c=='C') $r[0] = strtoupper($r[0]);
  if ($etAl!='*')
    $r = preg_replace('/,\s.*\sand\s.*(\(.*?\))/',' et&nbsp;al. $1', $r);
  if (@$apos) $r = preg_replace('/^(.*?)\s+\(/','$1'.$apos.' (',$r);
  if ($t=='y') {
    $t = '*'; $r = preg_replace('/^.*?(\d{4}\s\()/','$1',$r);
  } elseif ($t=='Y') {
    $t = 'T'; $r = preg_replace('/^.*?(\d{4}\s\()/','$1',$r);
  } else
    $r = preg_replace('/\s\d{4}\s\(/',' (',$r);
  $r = $pre . ($note ? str_replace(')',",&nbsp;$note)",$r) : $r);
  if ($t=='t') $r = preg_replace('/^.*?\((.*?\))/',
    '('.($NumberReferences ? $pre : '').'$1', $r);
  elseif ($t=='T') $r = preg_replace('/\s\(.*?\)$/', $p=='P' ? ')' : '', $r);
  elseif ($t=='i') $r = str_replace('()','(&ndash;)','('.trim("$pre$note").')');
  if ($p=='P') $r = '('.str_replace(array(' (','(',')'),array(', ','',''),$r).')';
  if ($implied) $p = 'p';
  return ($p=='p') ? str_replace(array('(',')'), array('',''), $r) : 
    ($NumberReferences ? str_replace(array('(',')'),array('&#91;','&#93;'),$r) : $r);
}

### --- This next block handles forms for editing citation text --- ###

SDV($CitationTemplate,array('$Group.CitationTemplate','Site.CitationTemplate'));
$HandleActions['cite'] = 'HandleCite';
$HandleActions['savecite'] = 'HandleSaveCite';
$HandleActions['changecite'] = 'HandleChangeCite';
SDV($AbbreviationTemplate,
  array('$Group.AbbreviationTemplate','Site.AbbreviationTemplate'));
$HandleActions['abbr'] = 'HandleAbbr';
$HandleActions['saveabbr'] = 'HandleSaveAbbr';

# replaces oldkey with newkey, in response to a request to change a cite key
function HandleChangeCite($pagename,$auth='edit') {
  global $WikiFormSubmit,$CitePattern;
  Lock(2);
  $oldref = $_REQUEST['oldref'];
  $newref = $_REQUEST['newref'];
  $page = RetrieveAuthPage($pagename, $auth, true, READPAGE_CURRENT);
  $txt  = preg_replace("/([Cc]ite-?[PpTt]?\((?:\"[^\"]*\"\s*)?)$oldref([\s\"\)])/",
    '$1'.$newref.'$2',MarkupEscape($page['text']));
  $_POST['text'] = MarkupRestore($txt);
  $_POST['csum'] = "$oldref to $newref";
  if(get_magic_quotes_gpc()==1) $_POST['text'] = addslashes($_POST['text']);
  SDV($WikiFormSubmit,'post');
  $_POST[$WikiFormSubmit] = 1;
  HandleEdit($pagename,$auth);
}
# adds a citation to a page, in response to a request from a citation edit form
# if the citation is defined, it is updated; otherwise, it is added
function HandleSaveCite($pagename,$auth='edit') {
  global $CitationTemplate, $WikiFormSubmit;
  $f = FormFields($pagename,$CitationTemplate);
  $e = 'element';
  $a = str_replace('yyyy-mm-dd','',implode('-',$_POST[$f[6][$e]]));
  $r = $_POST[$f[4][$e]].($_POST[$f[5][$e]] ? '"'.$_POST[$f[5][$e]] : '');
  $newcite = $_POST[$f[1][$e]].' '.$_POST[$f[0][$e]].($r ? "\"$r\"" : '').' : '.
    $_POST[$f[2][$e]].($a ? "\"$a\"" : '');
  Lock(2);
  $ref = $_REQUEST['refid'];
  $page = RetrieveAuthPage($pagename, $auth, true, READPAGE_CURRENT);
  if(get_magic_quotes_gpc()==1) $page['text'] = addslashes($page['text']);
  $_POST['text'] = ReplaceCitationText($ref,$newcite,$page['text']);
  $_POST['csum'] = $_POST[$f[0][$e]];
  if (isset($_REQUEST['onsubmit'])) $WikiFormSubmit = $_REQUEST['onsubmit'];
  else SDV($WikiFormSubmit,'post');
  $_POST[$WikiFormSubmit] = 1;
  HandleEdit($pagename,$auth);
}
# hide text inside [= ... =] brackets, to stop it from being parsed
if (!function_exists('MarkupEscape')) {
  function MarkupEscape($text) {
    global $EscapePattern;
    SDV($EscapePattern, '\\[([=@]).*?\\1\\]');
    return preg_replace("/$EscapePattern/es", "Keep(PSS('$0'))", $text);
  }
  function MarkupRestore($text) {
    global $KeepToken, $KPV;
    return preg_replace("/$KeepToken(\\d.*?)$KeepToken/e", "\$KPV['$1']", $text);
  }
}
# insert a citation into a bib block, replacing an existing entry, or adding a
# new entry, or adding a new bib block, as appropriate
function ReplaceCitationText($ref,$new,$text) {
  $txt = MarkupEscape($text);
  if (preg_match("/^(.*?\(:bib.*?:\))(.*?)(\n\(:bibend:\).*?)$/s",$txt,$match))
    $out = $match[1].(preg_match("/([*#:]\s*$ref.*?)(\n[*#:])/s",$match[2]."\n*",$m)
      ? str_replace($m[1],"$new\n",$match[2]) : $match[2]."\n$new\n").$match[3];
  else 
    $out = $txt . "\n(:bib:)\n$new\n\n(:bibend:)";
  return MarkupRestore($out);
}
# given a citation key and a page of text, return the text of the citation
function ExtractCitationText($ref,$text) {
  $r = "* $ref ";
  $txt = MarkupEscape($text);
  if (preg_match("/\(:bib.*?:\)(.*?)\n\(:bibend:\)/s",$txt,$match)) {
    preg_match("/([*#:]\s*$ref.*?)(\n[*#:])/s",$match[1]."\n$r\n*",$m);
    $r = MarkupRestore($m[1]);
  }
  return $r;
}
# load the component parts of a citation into an array, ready for form display
# called from the EntryForm function
function CitationValues($pagename,$fields,$auth='read') {
  global $CitePattern;
  $fvals = array(); $ferrs = array(); $ref = $_REQUEST['refid'];
  $page = RetrieveAuthPage($pagename, $auth, true, READPAGE_CURRENT);
  $citation = ExtractCitationText($ref,$page['text']);
  if (preg_match("/^([*#:])\s*($CitePattern?)(?:\s*\"([^\"]*)\"(?:([^\"]*)\")?)?".
    "(?:\s*[.:])?\s+(.*?)(?:\"([^\"]*)\")?$/s",$citation,$m)) {
    list($f[0], $f[2], $f[1], $f[5], $f[6], $f[3], $f[7]) = $m;
    for($n=0;$n<7;$n++)
      $fvals[$fields[$n]['element']] = str_replace('$','&#036;',
          htmlspecialchars($f[$n+1],ENT_QUOTES));
  }
  $GLOBALS['PCache'][$pagename]['time'] = $page['time'];
  return array('fv' => $fvals, 'fe' => $ferrs);
}
# make a form from which an author can pick a citation key from a list of 
# the keys defined in the page's bib block -- this lets us replace a 
# non-existent key with one that is already defined
function PickCiteReference($pagename, $opt) {
  global $PickCiteReferenceOpt, $FmtV, $CitePattern;
  SDVA($PickCiteReferenceOpt, array('go' => FmtPageName('$[Go]', $pagename),
    'change' => 
    FmtPageName('$[Change $CountRef instance(s) of &ldquo;$OldRefid&rdquo; to]', 
      $pagename)));
  $opt = array_merge($PickCiteReferenceOpt, (array)$opt);
  $page = RetrieveAuthPage($pagename, 'read', true, READPAGE_CURRENT);
  $out = array();
  $txt = MarkupEscape($page['text']);
  if (preg_match("/\(:bib.*?:\)(.*?)\n\(:bibend:\)/s",$txt,$match))
    foreach(preg_split("/\n[*#:]\s*/",$match[1],-1, PREG_SPLIT_NO_EMPTY) as $t)
      if (preg_match("/^($CitePattern?)(?:\s*\"([^\"]*)\"(?:([^\"]*)\")?)?(?:\s*[.:])?\s+/",
        $t,$m)) $out[] = "<option value='$m[1]'>$m[1]</option>";
  $oldref = $_REQUEST['refid'];
  preg_match_all("/([Cc]ite-?[PpTtYy]?\((?:\"[^\"]*\"\s*)?)$oldref([\s\"\)])/",$txt,$m);
  $FmtV['$CountRef'] = count($m[1]);
  $FmtV['$PickCite'] = implode('',$out);
  $FmtV['$OldRefid'] = $oldref;
  return FmtPageName("<form 
    class='publish' action='\$ScriptUrl' method='get'><input 
    type='hidden' name='n' value='\$FullName' />{$opt['change']} <input
    type='hidden' name='action' value='changecite' /><input 
    type='hidden' name='oldref' value='\$OldRefid' /><select 
    name='newref'>\$PickCite</select> <input
    class='pubbutton' type='submit' 
    value=\"{$opt['go']}\" /></form>", $pagename);
}
# this generates a form for editing a new or existing citation entry
# if it's a new citation (key is not defined), there is an option to change
# the key; otherwise, we use the form field values to define the new citation
function HandleCite($pagename,$auth='edit') {
  global $HandleCiteFmt,$PageStartFmt,$CiteFormFmt,$PageEndFmt,$FmtP,
    $CitationTemplate,$SaveEformAction,$CiteSpacedFunction,$FormValuesFunction,
    $NewCitation;
  SDV($FormValuesFunction, 'CitationValues'); SDV($SaveEformAction, 'savecite');
  SDV($NewCitation, '$Group.NewCitation Site.NewCitation');
  $opt = Array('refid' => $_REQUEST['refid'], 
    'deftext' => $CiteSpacedFunction($_REQUEST['refid']));
  $FmtP['/\\$LastModified/e'] = '$GLOBALS[\'CurrentTime\']';
  SDV($HandleCiteFmt,
    array(&$PageStartFmt,&$CiteFormFmt,&$PageEndFmt));
  if ($_REQUEST['pick']) {
    $opt['list'] = '*';
    array_splice($HandleCiteFmt, 1, 0, "wiki: $NewCitation");
    Markup('citeref','directives','/\(:cite(\s*.*?):\)/e',
      "Keep(PickCiteReference(\$pagename, ParseArgs(PSS('$1'))))");
  }
  $CiteFormFmt = 
    EntryForm($pagename,'savecite','post',$CitationTemplate,$opt);
  PrintFmt($pagename,$HandleCiteFmt);
}

# this is a stub to fool the EntryForm function into supporting abbreviations
function AbbreviationValues($pagename,$fields,$auth='read') {
    $fvals = array(); $ferrs = array();
    $page = RetrieveAuthPage($pagename, $auth, true, READPAGE_CURRENT);
    $GLOBALS['PCache'][$pagename]['time'] = $page['time'];
    return array('fv' => $fvals, 'fe' => $ferrs);
}
# this generates a form to enter a new abbreviation and add it to the
# abbreviations page -- on display, the abbreviation is spelled out
function HandleAbbr($pagename,$auth='edit') {
  global $HandleAbbrFmt,$PageStartFmt,$AbbrFormFmt,$PageEndFmt,
    $AbbreviationTemplate,$SaveEformAction,$FormValuesFunction;
  SDV($FormValuesFunction, 'AbbreviationValues'); 
  SDV($SaveEformAction,    'saveabbr');
  $opt = Array('return' => $_REQUEST['return'], 'abbr' => $_REQUEST['abbr']);
  SDV($HandleAbbrFmt,
    array(&$PageStartFmt,&$AbbrFormFmt,&$PageEndFmt));
  $AbbrFormFmt = 
    EntryForm($pagename,'saveabbr','post',$AbbreviationTemplate,$opt);
  PrintFmt($pagename,$HandleAbbrFmt);
}
# save a new abbreviation to an abbreviations page and return to requesting page
function HandleSaveAbbr($pagename,$auth='edit') {
  global $WikiFormSubmit, $EditRedirectFmt;
  Lock(2);
  $EditRedirectFmt = $_POST['return'];
  $page = RetrieveAuthPage($pagename, $auth, true, READPAGE_CURRENT);
  $_POST['text'] = ':'.$_POST['abbr'].':'.$_POST['abbrtext']."\n".$page['text'];
  $_POST['csum'] = $_POST['abbr'];
  if(get_magic_quotes_gpc()==1) $_POST['text'] = addslashes($_POST['text']);
  SDV($WikiFormSubmit,'post');
  $_POST[$WikiFormSubmit] = 1;
  HandleEdit($pagename,$auth);
}

?>